// $Id: irc.h,v 1.16 2003/01/10 00:41:39 toast Exp $

#ifndef _IRC_H_
#define _IRC_H_

#include <sys/types.h>
#include <unistd.h>

#include <string>
#include "oomon.h"
#include "strtype"
#include "dcc.h"
#include "remote.h"
#include "klines.h"

class IRC
{
private:
  static bool connected; // Are we connected to a server?
  static int plug; // Stores socket fd
  static bool AmIAnOper; // duh
  static bool GettingCASVCSReports;
  static bool GettingKlines;
  static bool GettingDlines;
  static std::string MyNick;
  static std::string Server_Name;
  static KlineList Klines;
  static KlineList Dlines;
  static unsigned long HostAddr;
  static unsigned long myaddr;

  static void Parse(std::string text);
  static void OnCTCP(const std::string & From, const std::string & UserHost,
    const std::string & To, std::string Text);
  static void OnPrivmsg(const std::string &, const std::string &,
    const std::string &, std::string);
  static void OnNotice(const std::string &, const std::string &,
    const std::string &, std::string);
public:
  static int Connect();
  static int Disconnect(const std::string & Message = "Normal termination");
  static void SetFD(fd_set & theset);
  static int Process(const fd_set & theset);
  static int Write(const std::string & msg);
  static void Notice(const std::string &, const std::string &);
  static void Msg(const std::string &, const std::string &);
  static void CTCP(const std::string &, const std::string &);
  static void CTCPreply(const std::string &, const std::string &);
  static void IsOn(const std::string &);
  static void Kline(const std::string &, const int, const std::string &,
    const std::string &);
  static void Unkline(const std::string &, const std::string &);
  static void Dline(const std::string &, const std::string &,
    const std::string &);
  static void Undline(const std::string &, const std::string &);
  static void Kill(const std::string &, const std::string &,
    const std::string &);
  static void Trace(const std::string & Target = "");
  static void StatsL(const std::string &);
  static void Retrace(const std::string &);
  static void ReloadKlines(const std::string &);
  static void ReloadDlines(const std::string &);
  static std::string GetServerName();
  static void FindK(StrList &, const std::string &);
  static void FindD(StrList &, const std::string &);
  static unsigned long GetHostAddr();
  static unsigned long GetMyAddr() { return myaddr; }
  static void Op(const std::string &, const std::string &);
  static void Join(const std::string &, const std::string &);
  static void Part(const std::string &);
};

#endif
