// $Id: proxy.h,v 1.7 2003/01/16 20:50:02 toast Exp $

#ifndef _PROXY_H_
#define _PROXY_H_

#include <sys/types.h>
#include <unistd.h>

#include <string>

#include "oomon.h"

class Proxy
{
public:
  enum ProxyType { SOCKS4, WINGATE };

private:
  static class Proxy *items[];
  static int count;

  bool connected, gotdata;
  std::string Address, Hostname, Nick, Userhost;
  int plug;
  time_t LastActive;

  void PrivSetFD(fd_set &, fd_set &) const;
  bool PrivProcess(const fd_set &, const fd_set &);
  int GetIdle() const;
protected:
  void initialize(const int, const std::string &, const std::string &,
    const std::string &, const std::string &);
  void Disconnect();
  int Write(char *, int);
  std::string GetAddress() const;
  std::string GetHostname() const;
  std::string GetNick() const;
  std::string GetUserhost() const;
  virtual ProxyType GetType() const = 0;
  virtual bool Parse(std::string) = 0;
  virtual bool OnConnect() = 0;
public:
  static int Connect(const std::string &, ProxyType, const std::string &,
    const std::string &, const std::string &);
  static void SetFD(fd_set &, fd_set &);
  static int Process(const fd_set &, const fd_set &);
  static bool Detecting(const std::string &, ProxyType);

  Proxy() { };
  ~Proxy() { this->Disconnect(); };
};

#endif
